///*
// * solver.hpp
// *
// *  Created on: Jan 28, 2012
// *      Author: Bergman, Cire
// */
//
//#ifndef INDEPSET_SOLVER_HPP_
//#define SETCOVER_SOLVER_HPP_
//
//#define EXACT_BDD -1
//
//#include "../instance/instance.hpp"
//#include "../bdd/bdd.hpp"
//#include "../util/stats.hpp"
//#include "indepset_solver.hpp"
//#include "intset.hpp"
//
//#include <queue>
//#include <map>
//#include <vector>
//
//using namespace std;
//
//
//struct SetCoverSolver {
//
//	NodeMap  						node_list;				/**< global pool of nodes */
//	vector<Node*>					nodes_layer;			/**< nodes in a layer */
//
//	SetCoverInst* 					inst;					/**< set covering instance */
//
//	int								width;					/**< BDD width */
//
//
////	vector<int>						active_vertices;
////	int*							in_state_counter;
////	int*							active_vertex_map;
////
//
////
////	vector<Node*>					temporary_branch_nodes;
////
//
////	bool						    relax;
////
////	int								layer;
////
////	/**
////	 * Branch and bound attributes
////	 */
////	int								global_LB;
////	int								global_UB;
////
////
////	Bounds							branch_and_bound();
//
//	vector<bool>					selected_var;
//
//	// auxiliaries
//	int  generate_relaxation(IntSet &initial_state, int initial_shortest_path);
//	int  generate_restriction(IntSet &initial_state, int initial_shortest_path);
//
//	int  choose_next_vertex();
//
//	void relax_layer_shortestpath();
//	void restrict_layer_shortestpath();
//
//	void update_node_match(Node* nodeA, Node* nodeB);
//
//
//	SetCoverSolver(SetCoverInst* _inst, int _width);
//
//
//	/**
//	 * Preprocessing
//	 */
//
//	vector<int> num_vars_per_const;			/**< number of active variables per constraint */
//};
//
//
//inline SetCoverSolver::SetCoverSolver(SetCoverInst* _inst, int _width) : inst(_inst), width(_width)
//{
////	relax = false;
//
////	in_state_counter = new int[inst->graph->n_vertices];
////	active_vertex_map = new int[inst->graph->n_vertices];
//
//	if( width != EXACT_BDD )
//		nodes_layer.reserve(2*width);
//	else {
//		nodes_layer.reserve(100000000);
//	}
//
////	temporary_branch_nodes.reserve(1000);
//}
//
//
//
//
//
//
//
//inline void SetCoverSolver::update_node_match(Node* nodeA, Node* nodeB) {
//
//	int min = MIN(nodeA->longest_path, nodeB->longest_path);
//
//	nodeA->longest_path = min;
//	nodeB->longest_path = min;
//
////	if( nodeA->longest_path > nodeB->longest_path ) {
////
////		if( nodeB->exact && !nodeA->exact ) {
////			//cout << "\t\tAdded " << nodeB->state << " to temporary branch nodes" << endl;
////			temporary_branch_nodes.push_back(
////					new Node(nodeB->state, nodeB->longest_path, false));
////			nodeB->exact = false;
////		}
////		nodeB->longest_path = nodeA->longest_path;
////
////	} else if( nodeB->longest_path > nodeA->longest_path ) {
////
////		if( nodeA->exact && !nodeB->exact ) {
////			//cout << "\t\tAdded " << nodeA->state << " to temporary branch nodes" << endl;
////			temporary_branch_nodes.push_back(
////					new Node(nodeA->state, nodeA->longest_path, false));
////			nodeA->exact = false;
////		}
////		nodeA->longest_path = nodeB->longest_path;
////
////	} else {
////		nodeA->exact = (nodeA->exact || nodeB->exact);
////		nodeB->exact = (nodeA->exact || nodeB->exact);
////	}
//}
//
//
//
//
//
//#endif /* INDEPSET_SOLVER_HPP_ */
